=== debian/changelog ===
i2pd (2.17.0-3build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 23:21:53 +0000

i2pd (2.17.0-3) unstable; urgency=medium

  * Fix libatomic detection (Closes: #886376)
  * Fix FTBFS on i386 (Closes: #887303)
  * Fix FTBFS on hurd-i386 (Closes: #887336)

 -- Yangfl <mmyangfl@gmail.com>  Mon, 15 Jan 2018 14:54:27 +0800

i2pd (2.17.0-2) unstable; urgency=medium

  * Fix wrong ITP number (Closes: #883770)
  * Switch buildsystem to CMake
  * Add libatomic detection (Closes: #886376)
  * Fix CMake system-related options (Closes: #886377)
  * Add function multiversioning support (Closes: #886378, #886780)
  * Add systemd service file
  * Enable websocket support

 -- Yangfl <mmyangfl@gmail.com>  Sat, 06 Jan 2018 10:55:47 +0800

i2pd (2.17.0-1) unstable; urgency=medium

  * Initial release (Closes: #739860)

 -- Yangfl <mmyangfl@gmail.com>  Thu, 07 Dec 2017 21:01:36 +0800
