=== debian/control ===
Source: i2pd
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Yangfl <mmyangfl@gmail.com>
Uploaders:
 Boyuan Yang <073plan@gmail.com>,
Build-Depends: debhelper (>= 10), libboost-system-dev (>= 1.46), libboost-date-time-dev, libboost-filesystem-dev, libboost-program-options-dev, libminiupnpc-dev, libssl-dev, zlib1g-dev, cmake, libwebsocketpp-dev,
Standards-Version: 4.1.3
Homepage: http://i2pd.website
Vcs-Git: https://salsa.debian.org/yangfl-guest/i2pd.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/i2pd

Package: i2pd
Architecture: any
Pre-Depends: adduser
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base,
Suggests: i2pd-doc
Description: I2P Router written in C++
 I2P (Invisible Internet Protocol) is a universal anonymous network layer. All
 communications over I2P are anonymous and end-to-end encrypted, participants
 don't reveal their real IP addresses.
