=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean --buildsystem=cmake --sourcedirectory=build/

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake --sourcedirectory=build/ -- \
		-DWITH_UPNP=ON -DWITH_WEBSOCKETS=ON

override_dh_auto_build:
	dh_auto_build --buildsystem=cmake
