=== debian/changelog ===
i2pd (2.19.0-2build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:57:02 +0000

i2pd (2.19.0-2) unstable; urgency=medium

  * Fix FTBFS on non-amd64
  * Bump Standards-Version to 4.1.5

 -- Yangfl <mmyangfl@gmail.com>  Tue, 10 Jul 2018 17:00:14 +0800

i2pd (2.19.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.1.4
  * d/postinst: remove recursive chown

 -- Yangfl <mmyangfl@gmail.com>  Wed, 27 Jun 2018 11:42:20 +0800

i2pd (2.18.0-1) unstable; urgency=medium

  * New upstream release
  * Try to fix FTBFS on hurd-i386

 -- Yangfl <mmyangfl@gmail.com>  Thu, 01 Feb 2018 23:13:36 +0800
