=== debian/changelog ===
i2pd (2.23.0-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Tue, 29 Jan 2019 15:42:04 +0800

i2pd (2.22.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.3.0
  * Bump debhelper compat to 12

 -- Yangfl <mmyangfl@gmail.com>  Sun, 06 Jan 2019 21:09:47 +0800

i2pd (2.21.1-1) unstable; urgency=medium

  * New upstream release
  * Update Homepage

 -- Yangfl <mmyangfl@gmail.com>  Tue, 23 Oct 2018 14:33:18 +0800

i2pd (2.20.0-1) unstable; urgency=medium

  * New upstream release
  * Remove Boyuan Yang from uploaders list
  * Bump Standards-Version to 4.2.1

 -- Yangfl <mmyangfl@gmail.com>  Tue, 28 Aug 2018 19:10:06 +0800
