## i2pd 2.25.0

=== Makefile ===
# $OpenBSD$

V =	2.25.0
DISTNAME =	i2pd-${V}
DISTFILES =	i2pd-{}${V}${EXTRACT_SUFX}
CATEGORIES =	net
HOMEPAGE =	http://i2pd.website
COMMENT =	C++ port of the i2p router

MAINTAINER =	Ruben Llorente <porting@use.startmail.com>

# BSD 3-clause
PERMIT_PACKAGE_CDROM =	Yes

GH_ACCOUNT =	PurpleI2P
GH_PROJECT =	i2pd
GH_TAG =	${V}

WANTLIB =	${COMPILER_LIBCXX} boost_date_time boost_filesystem \
		boost_program_options boost_system  c crypto m ssl z
LIB_DEPENDS =	devel/boost

USE_GMAKE =	Yes

NO_TEST =	Yes

SYSCONFDIR =	${VARBASE}/i2pd/.i2pd/

do-install:
	${INSTALL_PROGRAM} ${WRKSRC}/i2pd ${PREFIX}/bin
	${INSTALL_DATA} ${WRKSRC}/libi2pd.a ${PREFIX}/lib
	${INSTALL_DATA} ${WRKSRC}/libi2pdclient.a ${PREFIX}/lib
	${INSTALL_DATA_DIR} ${PREFIX}/share/examples/i2pd/certificates/family
	${INSTALL_DATA_DIR} ${PREFIX}/share/examples/i2pd/certificates/reseed
	${INSTALL_DATA_DIR} ${PREFIX}/share/examples/i2pd/certificates/router
	${INSTALL_DATA} ${WRKSRC}/contrib/certificates/family/* \
		${PREFIX}/share/examples/i2pd/certificates/family
	${INSTALL_DATA} ${WRKSRC}/contrib/certificates/reseed/* \
		${PREFIX}/share/examples/i2pd/certificates/reseed
	${INSTALL_DATA} ${WRKSRC}/contrib/certificates/router/* \
		${PREFIX}/share/examples/i2pd/certificates/router
	${INSTALL_DATA} ${WRKSRC}/contrib/i2pd.conf \
		${PREFIX}/share/examples/i2pd/i2pd.conf
	${INSTALL_DATA} ${WRKSRC}/contrib/tunnels.conf \
		${PREFIX}/share/examples/i2pd/tunnels.conf

.include <bsd.port.mk>
