## i2pd 2.27.0

=== debian/changelog ===
i2pd (2.27.0-1) unstable; urgency=medium

  * New upstream release
    + Fix FTBFS with GCC-9 (Closes: #925715)
  * Bump Standards-Version to 4.4.0

 -- Yangfl <mmyangfl@gmail.com>  Mon, 08 Jul 2019 16:37:45 +0800
