=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: net
 Priority: optional
 Maintainer: Yangfl <mmyangfl@gmail.com>
-Build-Depends: debhelper (>= 12~), libboost-system-dev (>= 1.46), libboost-date-time-dev, libboost-filesystem-dev, libboost-program-options-dev, libminiupnpc-dev, libssl-dev, zlib1g-dev, cmake, libwebsocketpp-dev,
-Standards-Version: 4.3.0
+Build-Depends: debhelper-compat (= 12), libboost-system-dev (>= 1.46), libboost-date-time-dev, libboost-filesystem-dev, libboost-program-options-dev, libminiupnpc-dev, libssl-dev, zlib1g-dev, cmake, libwebsocketpp-dev,
+Standards-Version: 4.4.0
 Homepage: https://i2pd.website
 Vcs-Git: https://salsa.debian.org/yangfl-guest/i2pd.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/i2pd
