## i2pd 2.29.0

=== build/CMakeLists.txt ===
--- 
+++ 
@@ -81,6 +81,7 @@
   "${LIBI2PD_SRC_DIR}/Poly1305.cpp"
   "${LIBI2PD_SRC_DIR}/Ed25519.cpp"
   "${LIBI2PD_SRC_DIR}/NTCP2.cpp"
+  "${LIBI2PD_SRC_DIR}/Blinding.cpp"
 )
 
 if (WITH_WEBSOCKETS)
