=== debian/changelog ===
i2pd (2.29.0-1build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 20:35:27 +0000

i2pd (2.29.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.4.1

 -- Yangfl <mmyangfl@gmail.com>  Wed, 23 Oct 2019 13:05:20 +0800
