=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: i2pd
 Section: net
 Priority: optional
-Maintainer: Yangfl <mmyangfl@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends: debhelper-compat (= 12), libboost-system-dev (>= 1.46), libboost-date-time-dev, libboost-filesystem-dev, libboost-program-options-dev, libminiupnpc-dev, libssl-dev, zlib1g-dev, cmake, libwebsocketpp-dev,
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: https://i2pd.website
 Vcs-Git: https://salsa.debian.org/yangfl-guest/i2pd.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/i2pd
