=== debian/rules ===
--- 
+++ 
@@ -7,15 +7,20 @@
 
 include /usr/share/dpkg/architecture.mk
 
+export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
+
 ifneq ($(filter amd64 x32,$(DEB_HOST_ARCH)),)
-  export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -O3 -D__AES__ -D__AVX__
-else
-  export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
+  export DEB_CXXFLAGS_MAINT_APPEND  += -D__AES__ -D__AVX__
 endif
+
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 
 %:
+	dh $@
+
+.PHONY: build
+build:
 	dh $@
 
 override_dh_auto_clean:
