## i2pd 2.32.1

=== debian/changelog ===
i2pd (2.32.1-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper compat to 13

 -- Yangfl <mmyangfl@gmail.com>  Fri, 24 Jul 2020 12:55:59 +0800

i2pd (2.31.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.5.0
  * Add upstream metadata

 -- Yangfl <mmyangfl@gmail.com>  Mon, 20 Apr 2020 11:25:01 +0800
