## i2pd 2.35.0

=== debian/changelog ===
i2pd (2.35.0-1build1) hirsute; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 12 Dec 2020 13:07:14 +0100

i2pd (2.35.0-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Sat, 05 Dec 2020 17:23:05 +0800
